/* SPDX-License-Identifier: BSD-2-Clause */
/*
 * Copyright (c) 2021 MediaTek Inc.
 */

/* [File]            : conn_host_csr_top.h */
/* [Revision time]   : Sun Jul  4 21:03:54 2021 */
/* [Description]     : This file is auto generated by CODA */
/*                     reserved. */

#ifndef __CONN_HOST_CSR_TOP_REGS_H__
#define __CONN_HOST_CSR_TOP_REGS_H__

#include "hal_common.h"

#ifdef __cplusplus
extern "C" {
#endif


/* ************************************************************************** */
/*  */
/* CONN_HOST_CSR_TOP CR Definitions */
/*  */
/* ************************************************************************** */

#define CONN_HOST_CSR_TOP_BASE      (0x18060000 + CONN_INFRA_REMAPPING_OFFSET)

#define CONN_HOST_CSR_TOP_WF_BAND0_LPCTL_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0x010) /* 0010 */
#define CONN_HOST_CSR_TOP_WF_BAND0_IRQ_STAT_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0x014) /* 0014 */
#define CONN_HOST_CSR_TOP_WF_BAND0_IRQ_ENA_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0x018) /* 0018 */
#define CONN_HOST_CSR_TOP_WF_BAND1_LPCTL_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0x020) /* 0020 */
#define CONN_HOST_CSR_TOP_WF_BAND1_IRQ_STAT_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0x024) /* 0024 */
#define CONN_HOST_CSR_TOP_WF_BAND1_IRQ_ENA_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0x028) /* 0028 */
#define CONN_HOST_CSR_TOP_BGF_LPCTL_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0x030) /* 0030 */
#define CONN_HOST_CSR_TOP_BGF_IRQ_STAT_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0x034) /* 0034 */
#define CONN_HOST_CSR_TOP_BGF_IRQ_ENA_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0x038) /* 0038 */
#define CONN_HOST_CSR_TOP_BGF_FW_OWN_IRQ_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0x03C) /* 003C */
#define CONN_HOST_CSR_TOP_GPS_LPCTL_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0x040) /* 0040 */
#define CONN_HOST_CSR_TOP_GPS_IRQ_STAT_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0x044) /* 0044 */
#define CONN_HOST_CSR_TOP_GPS_IRQ_ENA_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0x048) /* 0048 */
#define CONN_HOST_CSR_TOP_WF_MD_LPCTL_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0x050) /* 0050 */
#define CONN_HOST_CSR_TOP_WF_MD_IRQ_STAT_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0x054) /* 0054 */
#define CONN_HOST_CSR_TOP_WF_MD_IRQ_ENA_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0x058) /* 0058 */
#define CONN_HOST_CSR_TOP_BT0_MCU_JTAG_CTRL_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0x080) /* 0080 */
#define CONN_HOST_CSR_TOP_BT1_MCU_JTAG_CTRL_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0x084) /* 0084 */
#define CONN_HOST_CSR_TOP_WF_MCU_JTAG_CTRL_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0x088) /* 0088 */
#define CONN_HOST_CSR_TOP_MCU_JTAG_STATUS_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0x08C) /* 008C */
#define CONN_HOST_CSR_TOP_CONN_ON_MISC_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0x0F0) /* 00F0 */
#define CONN_HOST_CSR_TOP_CONN_SYSSTRAP_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0x0F8) /* 00F8 */
#define CONN_HOST_CSR_TOP_CSR_DEADFEED_EN_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0x124) /* 0124 */
#define CONN_HOST_CSR_TOP_CR_CONN_INFRA_CFG_ON_DBG_MUX_SEL_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0x15C) /* 015C */
#define CONN_HOST_CSR_TOP_CR_CONN_INFRA_RGU_ON_DBG_MUX_SEL_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0x160) /* 0160 */
#define CONN_HOST_CSR_TOP_CONN_INFRA_WAKEPU_TOP_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0x1A0) /* 01A0 */
#define CONN_HOST_CSR_TOP_CONN_INFRA_WAKEPU_WF_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0x1A4) /* 01A4 */
#define CONN_HOST_CSR_TOP_CONN_INFRA_WAKEPU_BT_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0x1A8) /* 01A8 */
#define CONN_HOST_CSR_TOP_CONN_INFRA_WAKEPU_GPS_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0x1AC) /* 01AC */
#define CONN_HOST_CSR_TOP_CONN_INFRA_WAKEPU_FM_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0x1B0) /* 01B0 */
#define CONN_HOST_CSR_TOP_CONN_SEMA_M2_SW_RST_B_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0x1F0) /* 01F0 */
#define CONN_HOST_CSR_TOP_CONN_SEMA_M3_SW_RST_B_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0x1F4) /* 01F4 */
#define CONN_HOST_CSR_TOP_CONN_ON2OFF_TX_SLEEP_PROTECT_CTRL_CSR_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0x300) /* 0300 */
#define CONN_HOST_CSR_TOP_CONN_OFF2ON_TX_SLEEP_PROTECT_CTRL_CSR_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0x304) /* 0304 */
#define CONN_HOST_CSR_TOP_CONN_CONN2TOP_TX_SLEEP_PROTECT_CTRL_CSR_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0x314) /* 0314 */
#define CONN_HOST_CSR_TOP_CONN_CONN2TOP_RX_SLEEP_PROTECT_CTRL_CSR_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0x320) /* 0320 */
#define CONN_HOST_CSR_TOP_HOST_CONN_INFRA_SLP_CNT_CTL_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0x380) /* 0380 */
#define CONN_HOST_CSR_TOP_HOST_CONN_INFRA_SLP_CNT_SLP_STOP_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0x384) /* 0384 */
#define CONN_HOST_CSR_TOP_HOST_CONN_INFRA_SLP_TIMER_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0x388) /* 0388 */
#define CONN_HOST_CSR_TOP_HOST_CONN_INFRA_SLP_COUNTER_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0x38C) /* 038C */
#define CONN_HOST_CSR_TOP_HOST_MAILBOX_WF_W_R_ADDR_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0x700) /* 0700 */
#define CONN_HOST_CSR_TOP_HOST_MAILBOX_WF_SET_ADDR_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0x704) /* 0704 */
#define CONN_HOST_CSR_TOP_HOST_MAILBOX_WF_CLR_ADDR_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0x708) /* 0708 */
#define CONN_HOST_CSR_TOP_HOST_MAILBOX_WF1_W_R_ADDR_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0x710) /* 0710 */
#define CONN_HOST_CSR_TOP_HOST_MAILBOX_WF1_SET_ADDR_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0x714) /* 0714 */
#define CONN_HOST_CSR_TOP_HOST_MAILBOX_WF1_CLR_ADDR_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0x718) /* 0718 */
#define CONN_HOST_CSR_TOP_HOST_MAILBOX_BT_W_R_ADDR_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0x720) /* 0720 */
#define CONN_HOST_CSR_TOP_HOST_MAILBOX_BT_SET_ADDR_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0x724) /* 0724 */
#define CONN_HOST_CSR_TOP_HOST_MAILBOX_BT_CLR_ADDR_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0x728) /* 0728 */
#define CONN_HOST_CSR_TOP_HOST_MAILBOX_BT1_W_R_ADDR_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0x730) /* 0730 */
#define CONN_HOST_CSR_TOP_HOST_MAILBOX_BT1_SET_ADDR_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0x734) /* 0734 */
#define CONN_HOST_CSR_TOP_HOST_MAILBOX_BT1_CLR_ADDR_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0x738) /* 0738 */
#define CONN_HOST_CSR_TOP_HOST_MAILBOX_GPS_W_R_ADDR_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0x740) /* 0740 */
#define CONN_HOST_CSR_TOP_HOST_MAILBOX_GPS_SET_ADDR_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0x744) /* 0744 */
#define CONN_HOST_CSR_TOP_HOST_MAILBOX_GPS_CLR_ADDR_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0x748) /* 0748 */
#define CONN_HOST_CSR_TOP_WF_CSR_DUMMY_CR_0_ADDR_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0x780) /* 0780 */
#define CONN_HOST_CSR_TOP_WF_CSR_DUMMY_CR_1_ADDR_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0x784) /* 0784 */
#define CONN_HOST_CSR_TOP_WF1_CSR_DUMMY_CR_0_ADDR_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0x788) /* 0788 */
#define CONN_HOST_CSR_TOP_WF1_CSR_DUMMY_CR_1_ADDR_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0x78C) /* 078C */
#define CONN_HOST_CSR_TOP_BGF_CSR_DUMMY_CR_0_ADDR_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0x790) /* 0790 */
#define CONN_HOST_CSR_TOP_BGF_CSR_DUMMY_CR_1_ADDR_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0x794) /* 0794 */
#define CONN_HOST_CSR_TOP_BGF1_CSR_DUMMY_CR_0_ADDR_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0x798) /* 0798 */
#define CONN_HOST_CSR_TOP_BGF1_CSR_DUMMY_CR_1_ADDR_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0x79C) /* 079C */
#define CONN_HOST_CSR_TOP_WF_MD_SRATUS_SYNC_W_R_ADDR_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0x7B0) /* 07B0 */
#define CONN_HOST_CSR_TOP_WF_MD_SRATUS_SYNC_SET_ADDR_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0x7B4) /* 07B4 */
#define CONN_HOST_CSR_TOP_WF_MD_SRATUS_SYNC_CLR_ADDR_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0x7B8) /* 07B8 */
#define CONN_HOST_CSR_TOP_RSV0_BACKUP_W_R_ADDR_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0x7C0) /* 07C0 */
#define CONN_HOST_CSR_TOP_RSV0_BACKUP_SET_ADDR_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0x7C4) /* 07C4 */
#define CONN_HOST_CSR_TOP_RSV0_BACKUP_CLR_ADDR_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0x7C8) /* 07C8 */
#define CONN_HOST_CSR_TOP_CONN_INFRA_SYSSTRAP_OUT_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0xA00) /* 0A00 */
#define CONN_HOST_CSR_TOP_CONN_INFRA_CFG_ON_DBG_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0xA04) /* 0A04 */
#define CONN_HOST_CSR_TOP_CONN_INFRA_RGU_ON_DBG_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0xA08) /* 0A08 */
#define CONN_HOST_CSR_TOP_CONN_INFRA_CLKGEN_ON_DBG_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0xA0C) /* 0A0C */
#define CONN_HOST_CSR_TOP_CONNSYS_PWR_STATES_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0xA10) /* 0A10 */
#define CONN_HOST_CSR_TOP_WF_ON_MONFLG_EN_FR_HIF_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0xB00) /* 0B00 */
#define CONN_HOST_CSR_TOP_WF_ON_MONFLG_SEL_FR_HIF_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0xB04) /* 0B04 */
#define CONN_HOST_CSR_TOP_WF_OFF_MONFLG_EN_FR_HIF_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0xB08) /* 0B08 */
#define CONN_HOST_CSR_TOP_WF_OFF_MONFLG_SEL_FR_HIF_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0xB0C) /* 0B0C */
#define CONN_HOST_CSR_TOP_WF_ON_MONFLG_OUT_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0xB10) /* 0B10 */
#define CONN_HOST_CSR_TOP_WF_MCUSYS_ON_MODULE_SEL_FR_HIF_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0xB14) /* 0B14 */
#define CONN_HOST_CSR_TOP_BGF_MONFLG_ON_OUT_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0xC00) /* 0C00 */
#define CONN_HOST_CSR_TOP_CR_HOSTCSR2BGF_ON_DBG_SEL_ADDR \
	(CONN_HOST_CSR_TOP_BASE + 0xC04) /* 0C04 */

#ifdef __cplusplus
}
#endif

#endif /* __CONN_HOST_CSR_TOP_REGS_H__ */
