/* SPDX-License-Identifier: BSD-2-Clause */
/*
 * Copyright (c) 2021 MediaTek Inc.
 */

/* [File]            : wf_wfdma_ext_wrap_csr.h */
/* [Revision time]   : Sun Jul  4 21:06:55 2021 */
/* [Description]     : This file is auto generated by CODA */
/*                     reserved. */

#ifndef __WF_WFDMA_EXT_WRAP_CSR_REGS_H__
#define __WF_WFDMA_EXT_WRAP_CSR_REGS_H__

#include "hal_common.h"

#ifdef __cplusplus
extern "C" {
#endif


/* ************************************************************************** */
/*  */
/* WF_WFDMA_EXT_WRAP_CSR CR Definitions */
/*  */
/* ************************************************************************** */

#define WF_WFDMA_EXT_WRAP_CSR_BASE    (0x18027000 + CONN_INFRA_REMAPPING_OFFSET)

#define WF_WFDMA_EXT_WRAP_CSR_WFDMA_TOP_CTRL_CR_ADDR \
	(WF_WFDMA_EXT_WRAP_CSR_BASE + 0x00) /* 7000 */
#define WF_WFDMA_EXT_WRAP_CSR_WFDMA_PREFETCH_SRAM_MBIST_CTRL0_ADDR \
	(WF_WFDMA_EXT_WRAP_CSR_BASE + 0x04) /* 7004 */
#define WF_WFDMA_EXT_WRAP_CSR_WFDMA_PREFETCH_SRAM_MBIST_CTRL1_ADDR \
	(WF_WFDMA_EXT_WRAP_CSR_BASE + 0x08) /* 7008 */
#define WF_WFDMA_EXT_WRAP_CSR_WFDMA_PREFETCH_SRAM_MBIST_STATUS_ADDR \
	(WF_WFDMA_EXT_WRAP_CSR_BASE + 0x0C) /* 700C */
#define WF_WFDMA_EXT_WRAP_CSR_WFDMA_MSI_CONFIG_ADDR \
	(WF_WFDMA_EXT_WRAP_CSR_BASE + 0x2C) /* 702C */
#define WF_WFDMA_EXT_WRAP_CSR_WFDMA_HOST_CONFIG_ADDR \
	(WF_WFDMA_EXT_WRAP_CSR_BASE + 0x30) /* 7030 */
#define WF_WFDMA_EXT_WRAP_CSR_WED_RING_CONTROL_IDX_ADDR \
	(WF_WFDMA_EXT_WRAP_CSR_BASE + 0x34) /* 7034 */
#define WF_WFDMA_EXT_WRAP_CSR_DLY_INT_TICK_THRES_ADDR \
	(WF_WFDMA_EXT_WRAP_CSR_BASE + 0x38) /* 7038 */
#define WF_WFDMA_EXT_WRAP_CSR_WFDMA_SW_RST_ADDR \
	(WF_WFDMA_EXT_WRAP_CSR_BASE + 0x3C) /* 703C */
#define WF_WFDMA_EXT_WRAP_CSR_WFDMA_DBG_SEL_ADDR \
	(WF_WFDMA_EXT_WRAP_CSR_BASE + 0x40) /* 7040 */
#define WF_WFDMA_EXT_WRAP_CSR_WFDMA_HIF_MISC_ADDR \
	(WF_WFDMA_EXT_WRAP_CSR_BASE + 0x44) /* 7044 */
#define WF_WFDMA_EXT_WRAP_CSR_WFDMA_AXI_SLPPROT_CTRL_ADDR \
	(WF_WFDMA_EXT_WRAP_CSR_BASE + 0x50) /* 7050 */
#define WF_WFDMA_EXT_WRAP_CSR_WFDMA_AXI_SLPPROT_VIO_ADDR_ADDR \
	(WF_WFDMA_EXT_WRAP_CSR_BASE + 0x54) /* 7054 */
#define WF_WFDMA_EXT_WRAP_CSR_WFDMA_MBIST_FUSE_CTRL_ADDR \
	(WF_WFDMA_EXT_WRAP_CSR_BASE + 0x5C) /* 705C */
#define WF_WFDMA_EXT_WRAP_CSR_WFDMA_MBIST_PREFUSE_D_ADDR \
	(WF_WFDMA_EXT_WRAP_CSR_BASE + 0x60) /* 7060 */
#define WF_WFDMA_EXT_WRAP_CSR_WFDMA_DCM_CTRL_ADDR \
	(WF_WFDMA_EXT_WRAP_CSR_BASE + 0x74) /* 7074 */
#define WF_WFDMA_EXT_WRAP_CSR_WFDMA_MBIST_FUSE_CTRL1_ADDR \
	(WF_WFDMA_EXT_WRAP_CSR_BASE + 0x80) /* 7080 */
#define WF_WFDMA_EXT_WRAP_CSR_WFDMA_PF_MEM_DUMP_CTRL_ADDR \
	(WF_WFDMA_EXT_WRAP_CSR_BASE + 0xB0) /* 70B0 */
#define WF_WFDMA_EXT_WRAP_CSR_WFDMA_PF_MEM_DUMP_DDW0_ADDR \
	(WF_WFDMA_EXT_WRAP_CSR_BASE + 0xB4) /* 70B4 */
#define WF_WFDMA_EXT_WRAP_CSR_WFDMA_PF_MEM_DUMP_DDW1_ADDR \
	(WF_WFDMA_EXT_WRAP_CSR_BASE + 0xB8) /* 70B8 */
#define WF_WFDMA_EXT_WRAP_CSR_WFDMA_RRO_AXI_CAB_CTRL_ADDR \
	(WF_WFDMA_EXT_WRAP_CSR_BASE + 0xBC) /* 70BC */
#define WF_WFDMA_EXT_WRAP_CSR_WFDMA_HIF_PERF_MAVG_DIV_ADDR \
	(WF_WFDMA_EXT_WRAP_CSR_BASE + 0xC0) /* 70C0 */
#define WF_WFDMA_EXT_WRAP_CSR_WFDMA_HIF_PERF_FST_TRAN_STS_ADDR \
	(WF_WFDMA_EXT_WRAP_CSR_BASE + 0xC4) /* 70C4 */
#define WF_WFDMA_EXT_WRAP_CSR_WFDMA_BN0_FST_MPDU_TIME_STS_ADDR \
	(WF_WFDMA_EXT_WRAP_CSR_BASE + 0xC8) /* 70C8 */
#define WF_WFDMA_EXT_WRAP_CSR_WFDMA_BN0_FST_MPDU_LEN_STS_ADDR \
	(WF_WFDMA_EXT_WRAP_CSR_BASE + 0xCC) /* 70CC */
#define WF_WFDMA_EXT_WRAP_CSR_WFDMA_BN1_FST_MPDU_TIME_STS_ADDR \
	(WF_WFDMA_EXT_WRAP_CSR_BASE + 0xD0) /* 70D0 */
#define WF_WFDMA_EXT_WRAP_CSR_WFDMA_BN1_FST_MPDU_LEN_STS_ADDR \
	(WF_WFDMA_EXT_WRAP_CSR_BASE + 0xD4) /* 70D4 */
#define WF_WFDMA_EXT_WRAP_CSR_WFDMA_DLY_IDX_CFG_0_ADDR \
	(WF_WFDMA_EXT_WRAP_CSR_BASE + 0xE8) /* 70E8 */
#define WF_WFDMA_EXT_WRAP_CSR_WFDMA_DLY_IDX_CFG_1_ADDR \
	(WF_WFDMA_EXT_WRAP_CSR_BASE + 0xEC) /* 70EC */
#define WF_WFDMA_EXT_WRAP_CSR_MSI_INT_CFG0_ADDR \
	(WF_WFDMA_EXT_WRAP_CSR_BASE + 0XF0) /* 70F0 */
#define WF_WFDMA_EXT_WRAP_CSR_MSI_INT_CFG1_ADDR \
	(WF_WFDMA_EXT_WRAP_CSR_BASE + 0XF4) /* 70F4 */
#define WF_WFDMA_EXT_WRAP_CSR_MSI_INT_CFG2_ADDR \
	(WF_WFDMA_EXT_WRAP_CSR_BASE + 0XF8) /* 70F8 */
#define WF_WFDMA_EXT_WRAP_CSR_MSI_INT_CFG3_ADDR \
	(WF_WFDMA_EXT_WRAP_CSR_BASE + 0XFC) /* 70FC */
#define WF_WFDMA_EXT_WRAP_CSR_WED_HOST_INT_STA_ADDR \
	(WF_WFDMA_EXT_WRAP_CSR_BASE + 0x200) /* 7200 */
#define WF_WFDMA_EXT_WRAP_CSR_WED_HOST_INT_ENA_ADDR \
	(WF_WFDMA_EXT_WRAP_CSR_BASE + 0x204) /* 7204 */
#define WF_WFDMA_EXT_WRAP_CSR_WED_TX0_CTRL0_ADDR \
	(WF_WFDMA_EXT_WRAP_CSR_BASE + 0x300) /* 7300 */
#define WF_WFDMA_EXT_WRAP_CSR_WED_TX0_CTRL1_ADDR \
	(WF_WFDMA_EXT_WRAP_CSR_BASE + 0x304) /* 7304 */
#define WF_WFDMA_EXT_WRAP_CSR_WED_TX0_CTRL2_ADDR \
	(WF_WFDMA_EXT_WRAP_CSR_BASE + 0x308) /* 7308 */
#define WF_WFDMA_EXT_WRAP_CSR_WED_TX0_STS_ADDR \
	(WF_WFDMA_EXT_WRAP_CSR_BASE + 0x30C) /* 730C */
#define WF_WFDMA_EXT_WRAP_CSR_WED_TX1_CTRL0_ADDR \
	(WF_WFDMA_EXT_WRAP_CSR_BASE + 0x310) /* 7310 */
#define WF_WFDMA_EXT_WRAP_CSR_WED_TX1_CTRL1_ADDR \
	(WF_WFDMA_EXT_WRAP_CSR_BASE + 0x314) /* 7314 */
#define WF_WFDMA_EXT_WRAP_CSR_WED_TX1_CTRL2_ADDR \
	(WF_WFDMA_EXT_WRAP_CSR_BASE + 0x318) /* 7318 */
#define WF_WFDMA_EXT_WRAP_CSR_WED_TX1_STS_ADDR \
	(WF_WFDMA_EXT_WRAP_CSR_BASE + 0x31C) /* 731C */
#define WF_WFDMA_EXT_WRAP_CSR_WED_RX1_CTRL0_ADDR \
	(WF_WFDMA_EXT_WRAP_CSR_BASE + 0x410) /* 7410 */
#define WF_WFDMA_EXT_WRAP_CSR_WED_RX1_CTRL1_ADDR \
	(WF_WFDMA_EXT_WRAP_CSR_BASE + 0x414) /* 7414 */
#define WF_WFDMA_EXT_WRAP_CSR_WED_RX1_CTRL2_ADDR \
	(WF_WFDMA_EXT_WRAP_CSR_BASE + 0x418) /* 7418 */
#define WF_WFDMA_EXT_WRAP_CSR_WED_RX1_STS_ADDR \
	(WF_WFDMA_EXT_WRAP_CSR_BASE + 0x41C) /* 741C */
#define WF_WFDMA_EXT_WRAP_CSR_WFDMA_AXI0_R2A_CTRL_0_ADDR \
	(WF_WFDMA_EXT_WRAP_CSR_BASE + 0x500) /* 7500 */
#define WF_WFDMA_EXT_WRAP_CSR_WFDMA_AXI0_R2A_CTRL_1_ADDR \
	(WF_WFDMA_EXT_WRAP_CSR_BASE + 0x504) /* 7504 */
#define WF_WFDMA_EXT_WRAP_CSR_WFDMA_AXI0_R2A_CTRL_2_ADDR \
	(WF_WFDMA_EXT_WRAP_CSR_BASE + 0x508) /* 7508 */
#define WF_WFDMA_EXT_WRAP_CSR_WFDMA_AXI0_R2A_STS_ADDR \
	(WF_WFDMA_EXT_WRAP_CSR_BASE + 0x50C) /* 750C */
#define WF_WFDMA_EXT_WRAP_CSR_WFDMA_AXI0_R2A_DMAWR_PROBE_ADDR \
	(WF_WFDMA_EXT_WRAP_CSR_BASE + 0x510) /* 7510 */
#define WF_WFDMA_EXT_WRAP_CSR_WFDMA_AXI0_R2A_DMARD_PROBE_ADDR \
	(WF_WFDMA_EXT_WRAP_CSR_BASE + 0x514) /* 7514 */
#define WF_WFDMA_EXT_WRAP_CSR_WFDMA_AXI0_R2A_WR_DBG_AXIM_OUT0_ADDR \
	(WF_WFDMA_EXT_WRAP_CSR_BASE + 0x518) /* 7518 */
#define WF_WFDMA_EXT_WRAP_CSR_WFDMA_AXI0_R2A_WR_DBG_AXIM_OUT1_ADDR \
	(WF_WFDMA_EXT_WRAP_CSR_BASE + 0x51C) /* 751C */
#define WF_WFDMA_EXT_WRAP_CSR_WFDMA_AXI0_R2A_AXI_SLP_STS_ADDR \
	(WF_WFDMA_EXT_WRAP_CSR_BASE + 0x520) /* 7520 */
#define WF_WFDMA_EXT_WRAP_CSR_WFDMA_AXI0_R2A_RD_DBG_AXIM_OUT0_ADDR \
	(WF_WFDMA_EXT_WRAP_CSR_BASE + 0x524) /* 7524 */
#define WF_WFDMA_EXT_WRAP_CSR_WFDMA_AXI0_R2A_RD_DBG_AXIM_OUT1_ADDR \
	(WF_WFDMA_EXT_WRAP_CSR_BASE + 0x528) /* 7528 */
#define WF_WFDMA_EXT_WRAP_CSR_WFDMA_AXI0_R2A_FSM_CMD_ST_ADDR \
	(WF_WFDMA_EXT_WRAP_CSR_BASE + 0x52C) /* 752C */
#define WF_WFDMA_EXT_WRAP_CSR_WFDMA_AXI0_R2A_FSM_DAT_ST_ADDR \
	(WF_WFDMA_EXT_WRAP_CSR_BASE + 0x530) /* 7530 */


#ifdef __cplusplus
}
#endif

#endif /* __WF_WFDMA_EXT_WRAP_CSR_REGS_H__ */
