/* SPDX-License-Identifier: BSD-2-Clause */
/*
 * Copyright (c) 2021 MediaTek Inc.
 */

/*
 ** Id: //Department/DaVinci/BRANCHES/
 *			MT6620_WIFI_DRIVER_V2_3/include/chips/mt7668.h#1
 */

/*! \file  mt7668.h
 *    \brief This file contains the info of MT7668
 */

#ifndef _MT7668_H
#define _MT7668_H

/*******************************************************************************
 *                         C O M P I L E R   F L A G S
 *******************************************************************************
 */

/*******************************************************************************
 *                    E X T E R N A L   R E F E R E N C E S
 *******************************************************************************
 */

/*******************************************************************************
 *                              C O N S T A N T S
 *******************************************************************************
 */
#define MT7668_CHIP_ID					(0x7668)
#define MT7668_SW_SYNC0					WIFI_RGU_SW_SYNC0
#define MT7668_SW_SYNC0_RDY_OFFSET		WIFI_RGU_SYNC0_RDY_OFFSET
#define MT7668_PATCH_START_ADDR			(0x000C8000)
#define MT7668_TOP_CFG_BASE			(0x0000)
#define MT7668_TX_DESC_APPEND_LENGTH            44
#define MT7668_RX_DESC_LENGTH                   16
#define MT7668_RX_INIT_EVENT_LENGTH             8
#define MT7668_RX_EVENT_HDR_LENGTH              12

/*******************************************************************************
 *                         D A T A   T Y P E S
 *******************************************************************************
 */

/*******************************************************************************
 *                            P U B L I C   D A T A
 *******************************************************************************
 */

/*******************************************************************************
 *                           P R I V A T E   D A T A
 *******************************************************************************
 */

/*******************************************************************************
 *                                 M A C R O S
 *******************************************************************************
 */

/*******************************************************************************
 *                  F U N C T I O N   D E C L A R A T I O N S
 *******************************************************************************
 */

/*******************************************************************************
 *                              F U N C T I O N S
 *******************************************************************************
 */

#endif /* _MT7668_H */


